/*
** Copyright (c) Massachusetts Institute of Technology 1994, 1995, 1996.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. This code may not be re-distributed or modified
**        without permission from MIT (contact 
**        lclint-request@larch.lcs.mit.edu.)  
**
**        Modification and re-distribution are encouraged,
**        but we want to keep track of changes and
**        distribution sites.
*/

typedef enum 
{ 
  XPK_CONST, XPK_VAR, XPK_TYPE, 
  XPK_FCN, XPK_CLAIM, XPK_ITER 
} exportKind;

typedef struct _exportNode {
  exportKind kind;
  union {
    constDeclarationNode constdeclaration;
    varDeclarationNode vardeclaration;
    typeNode type;
    fcnNode fcn;
    claimNode claim;
    iterNode iter;
  } content;
} *exportNode;

extern /*@unused@*/ /*@only@*/ cstring exportNode_unparse (exportNode p_n);

