/*
** Copyright (c) Massachusetts Institute of Technology 1994, 1995, 1996.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. This code may not be re-distributed or modified
**        without permission from MIT (contact 
**        lclint-request@larch.lcs.mit.edu.)  
**
**        Modification and re-distribution are encouraged,
**        but we want to keep track of changes and
**        distribution sites.
*/
/*
** typeIdSet.h
**
** based on set_template.h
*/

# ifndef typeIdSET_H
# define typeIdSET_H

/* in forwardTypes.h: immut_typedef int typeIdSet;  */

extern typeIdSet typeIdSet_emptySet (void) 
   /*@modifies internalState@*/ ;

extern bool typeIdSet_member (typeIdSet p_t, typeId p_el) /*@*/ ;
extern bool typeIdSet_isEmpty (/*@sef@*/ typeIdSet p_t) /*@*/ ;

extern typeIdSet typeIdSet_single (typeId p_t)
   /*@modifies internalState@*/ ;

extern typeIdSet typeIdSet_singleOpt (typeId p_t)
   /*@modifies internalState@*/ ;

extern typeIdSet typeIdSet_insert (typeIdSet p_t, typeId p_el) 
   /*@modifies internalState@*/ ;

extern typeIdSet typeIdSet_removeFresh (typeIdSet p_t, typeId p_el) 
  /*@modifies internalState@*/ ;

extern cstring typeIdSet_unparse (typeIdSet p_t) /*@*/ ;

extern typeIdSet typeIdSet_subtract (typeIdSet p_s, typeIdSet p_t) 
   /*@modifies internalState*/ ;

extern int typeIdSet_compare (typeIdSet p_t1, typeIdSet p_t2);
extern cstring typeIdSet_dump (typeIdSet p_t);
extern typeIdSet typeIdSet_undump (char **p_s) 
   /*@modifies internalState, *p_s@*/ ;
extern typeIdSet typeIdSet_union (typeIdSet p_t1, typeIdSet p_t2) /*@*/ ; 

extern void typeIdSet_initMod (void) /*@modifies internalState@*/ ;
extern void typeIdSet_destroyMod (void) /*@modifies internalState@*/ ;

extern void typeIdSet_dumpTable (FILE *p_fout) /*@modifies *p_fout@*/ ;
extern void 
  typeIdSet_loadTable (FILE *p_fin) /*@modifies *p_fin, internalState@*/ ;

/*@constant typeIdSet typeIdSet_undefined;@*/
# define typeIdSet_undefined 0

/*@constant typeIdSet typeIdSet_empty;@*/
# define typeIdSet_empty 0

# else
# error "Multiple include"
# endif

